/*
 * Copyright 2021 - 2022 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.springframework.sbm.project.resource;

public abstract class BaseProjectResource implements InternalProjectResource {
    protected boolean isChanged = false;
    private boolean isDeleted = false;

    public boolean hasChanges() {
        return isChanged;
    }

    public void resetHasChanges() {
        isChanged = false;
    }

    public void markAsChanged() {
        isChanged = true;
    }

    public void delete() {
        isDeleted = true;
        markAsChanged();
    }

    public boolean isDeleted() {
        return isDeleted;
    }
}
